<template lang="pug">
	.itemCarpeta(:class="[estado,{expandido}]")
		.titulo(
				:style="{ paddingLeft: margen() + 'rem' }"
				@click="tituloClick"
			)
			button( type="button", v-if="carpeta.subcarpetas.length", @click="alternar" )
			router-link( :to="this.ruta" )
				vector(src="@img/ico-carpeta.svg?inline")
				//-span {{nivel}} - {{ margen }}
				span {{ carpeta.nombre | capitalizar }}
		//-span {{ carpeta.id }} - {{ activa }} - {{ estado }}
		.subarbol( v-if="carpeta.subcarpetas.length" )
			ItemCarpeta(
				v-for="subcarpeta in carpeta.subcarpetas",
				:key="subcarpeta.id",
				:carpeta="subcarpeta",
				:nivel="nivel+1"
				:activa="activa"
				@activar="activar"
			)

</template>

<script>
	import { mapState } from "vuex";

	export default {
		name: "ItemCarpeta",
		props: {
			carpeta: {
				type: Object
			},
			nivel: {
				type: Number,
				default: 1
			},
			activa: {
				type: Number
			}
		},
		data() {
			return { expandido: false, disco: false };
		},
		computed: {
			ruta() {
				if (this.carpeta) {
					return "/disco/carpeta/" + this.carpeta.id;
				} else {
					return "/disco";
				}
			},
			estado() {
				return !this.disco &&
					this.carpeta.id == this.activa &&
					this.taxonomia == "carpeta"
					? "activo"
					: "";
			},
			...mapState(["taxonomia"])
		},
		watch: {
			$route({ name, params }) {
				console.debug(name);
				this.disco = name == "disco";
			}
		},
		methods: {
			margen() {
				//return this.nivel
				return (
					Math.floor(((2.5 + this.nivel) / (1 + this.nivel * 0.05)) * 4) /
					4
				);
			},
			alternar(evt) {
				this.expandido = !this.expandido;
				evt.stopPropagation();
			},
			tituloClick(evt) {
				//console.log( "click", this.carpeta.id, this.activa, this.estado );
				this.$emit("activar", this.carpeta.id);
			},
			activar(id, elem) {
				this.$emit("activar", id);
			}
		}
	};
</script>

<style lang="stylus" scoped>
	@import "~nib/index"
	@import "../stylus/base/utiles.styl"

	.itemCarpeta
		font-size calcRem( 11 )
		color tint( azul, 90% )
		border-radius 0 1rem 1rem 0

		&.activo
			background-color tint( azul, 40% )

	.titulo
		display flex
		align-items center
		padding .5em
		border-radius 0 1rem 1rem 0

		&:hover
			background-color alpha( tint( azul, 20% ), 50% )

		.activo > &
			background-color hover_lateral

		a
			flex 1 1 auto
			margin .2em
			color tint( azul, 90% )
			text-decoration none
			display flex
			align-items center

			.vector
				flex 0 0 20px
				width 20px
				margin 0 .2em

			span
				flex 1 1 auto
				margin .2em

		button
			outline none
			width 1.5em
			height @width
			margin-left -( @width )
			border none
			display flex
			align-items center
			justify-content center
			background-color transparent
			cursor pointer

			&:hover
				background-color tint( azul, 20% )

			&::before
				content ""
				width 0
				height 0
				border 4px solid transparente
				border-top 5px solid blanco
				border-bottom none
				display block
				transform rotate( -90deg )
				transition transform 150ms linear

				.expandido > &
					transform rotate( 0 )

	.subarbol
		overflow hidden
		max-height 0

		.expandido > &
			max-height 1000vh
</style>
